# OpenXG-AUSF



OpenXG-AUSF Arch
```
├── build:         Build directory, contains targets and object files generated by compilation of network functions. 
    ├── scripts:   Directory containing scripts for building network functions.
    ├── ext:       Directory containing pistache and the JSON and spdlog library.
    └── AUSF:       Directory containing object files generated by compilation of AUSF network function. 
├── etc:           Directory containing the configuration file to be deployed for AUSF.
└── src:           Source files of AUSF.
    ├── ausf_app:  AUSF Procedures handling logic. 
    ├── common:    Common definitions for 3GPP specifications.
    ├── 5gaka:     algorithms for 5G-AKA authentication procedures.
    ├── libngap:   ngap library.
    ├── utils:     Common utilities.  .
    ├── model:     AUSF service. 
    ├── api:       AUSF service.
    └── impl:      AUSF service.
```
    
## Download source code from Gitlab
```
git clone http://git.opensource5g.org/openxg/openxg-ausf.git
cd openxg-ausf/
git checkout master
```

## install dependencies
```
cd ./build/scripts
sudo ./build_ausf -I
```
## build AUSF
```
sudo ./build_ausf -c -b Debug -j
```
## launch AUSF
```
sudo ./build/AUSF/ausf -c etc/ausf.conf -o
```